SystemOrganization addCategory: #'Monticello2-Elements'!
SystemOrganization addCategory: #'Monticello2-Tests'!
SystemOrganization addCategory: #'Monticello2-Versions'!

TestCase subclass: #MDTestCase
	instanceVariableNames: 'proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestCase methodsFor: 'proxy access' stamp: 'avi 11/29/2004 12:49'!
methodProperty: aSymbol
	^ self 
		methodProperty: aSymbol 
		inClass: self defaultClassName
		atSelector: self defaultSelector! !

!MDTestCase methodsFor: 'configuration' stamp: 'avi 11/29/2004 14:57'!
changedSource2
	^ self defaultSource, '"changed2"'! !

!MDTestCase methodsFor: 'configuration' stamp: 'avi 11/29/2004 12:49'!
defaultSource
	^ 'hasTimestamp
	^ true'! !

!MDTestCase methodsFor: 'constructing' stamp: 'avi 11/29/2004 13:16'!
methodVersion
	^ MDElementVersion snapshot: self methodSnapshot! !

!MDTestCase methodsFor: 'configuration' stamp: 'avi 11/29/2004 12:49'!
defaultTimeStamp
	^  TimeStamp readFrom: '11/29/2004 01:44' readStream! !

!MDTestCase methodsFor: 'configuration' stamp: 'avi 11/29/2004 12:49'!
methodProperty: aSymbol inClass: aString atSelector: aSelector put: aValue
	self subclassResponsibility! !

!MDTestCase methodsFor: 'configuration' stamp: 'avi 11/29/2004 12:49'!
methodProperty: aSymbol inClass: aString atSelector: aSelector 
	self subclassResponsibility! !

MDTestCase subclass: #MDTestImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 11/28/2004 19:03'!
testUpdateDoesntChangeElement
	| snap original |
	snap := self methodSnapshot.
	original := snap element.
	proxy updateSnapshot: snap.
	self assert: snap element = original! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 11/28/2004 23:36'!
testCurrentDefinition
	| snap |
	self methodProperty: #source put: self defaultSource.
	snap := self methodSnapshot.
	proxy updateSnapshot: snap.
	self assert: (snap properties at: #source) = self defaultSource! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 11/29/2004 01:11'!
testLoadDefinition
	| snap |
	snap _ self methodSnapshot.
	snap properties 
			source: self defaultSource;
			author: self defaultAuthor;
			timeStamp: self defaultTimeStamp.
	proxy loadSnapshot: snap.
	self assert: (self methodProperty: #source) = self defaultSource! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'cwp 11/29/2004 01:13'!
testLoadAndUpdate
	| original retrieved |
	original _ self methodSnapshot.
	original properties 
		source: self defaultSource;
		author: self defaultAuthor;
		timeStamp: self defaultTimeStamp.
	proxy loadSnapshot: original.
	
	retrieved _ self methodSnapshot.
	proxy updateSnapshot: retrieved.
	self assert: original properties = retrieved properties! !

!MDTestImageProxy methodsFor: 'tests' stamp: 'avi 11/29/2004 13:42'!
testUpToDate
	| snap |
	snap _ self methodSnapshot.
	snap properties 
		source: self defaultSource.
	proxy loadSnapshot: snap.
	self assert: (proxy isUpToDate: snap).
	self methodProperty: #source put: self changedSource.
	self deny: (proxy isUpToDate: snap).! !

!MDTestImageProxy class methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 12:49'!
isAbstract
	^ self name = #MDTestImageProxy! !

MDTestImageProxy subclass: #MDTestSqueakImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestSqueakImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 23:34'!
methodProperty: propName inClass: className atSelector: aSelector 
	| class |
	class := self classNamed: className.
	propName = #source ifTrue: [^ class sourceCodeAt: aSelector].
	^ nil! !

!MDTestSqueakImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 23:20'!
proxyClass
	^ MDSqueakImageProxy! !

!MDTestSqueakImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 23:34'!
methodProperty: propName inClass: className atSelector: aSelector put: aValue
	| class |
	class := self classNamed: className.
	propName = #source ifTrue: [^ class compile: aValue].
	^ nil! !

!MDTestSqueakImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 23:35'!
classNamed: name
	^ Smalltalk at: name asSymbol! !

MDTestImageProxy subclass: #MDTestFakeImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 23:38'!
defaultSource
	^ 'one ^ 1'! !

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 18:57'!
methodProperty: aSymbol inClass: aString atSelector: aSelector put: aValue 
	| element |
	element := MDMethodElement className: aString selector: aSelector.
	(proxy at: element) at: aSymbol put: aValue! !

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 18:58'!
defaultClassName
	^'Test'! !

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 16:55'!
proxyClass
	^ MDFakeImageProxy! !

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 18:56'!
methodProperty: aSymbol inClass: aString atSelector: aSelector 
	| element |
	element := MDMethodElement className: aString selector: aSelector.
	^ (proxy at: element) at: aSymbol ifAbsent: [nil]! !

!MDTestFakeImageProxy methodsFor: 'configuration' stamp: 'cwp 11/28/2004 18:58'!
defaultSelector
	^ #method1! !

!MDTestCase methodsFor: 'constructing' stamp: 'avi 11/29/2004 14:13'!
updateVersion: anElementVersion property: aSymbol put: anObject
	| newSnapshot |
	newSnapshot _ anElementVersion snapshot copy.
	newSnapshot properties at: aSymbol put: anObject.
	^ MDElementVersion
		snapshot: newSnapshot
		ancestry: anElementVersion fullAncestry! !

!MDTestCase methodsFor: 'proxy access' stamp: 'avi 11/29/2004 12:49'!
methodProperty: aSymbol put: aValue
	^ self 
		methodProperty: aSymbol 
		inClass: self defaultClassName 
		atSelector: self defaultSelector 
		put: aValue! !

!MDTestCase methodsFor: 'configuration' stamp: 'avi 11/29/2004 12:49'!
proxyClass
	self subclassResponsibility! !

!MDTestCase methodsFor: 'configuration' stamp: 'avi 11/29/2004 12:49'!
defaultSelector
	^ #hasTimestamp! !

!MDTestCase methodsFor: 'running' stamp: 'avi 11/29/2004 12:49'!
setUp
	proxy _ self proxyClass new! !

!MDTestCase methodsFor: 'configuration' stamp: 'avi 11/29/2004 13:42'!
changedSource
	^ self defaultSource, '"changed"'! !

!MDTestCase methodsFor: 'configuration' stamp: 'avi 11/29/2004 12:49'!
defaultAuthor
	^ 'abc'! !

!MDTestCase methodsFor: 'configuration' stamp: 'avi 11/29/2004 12:49'!
defaultClassName
	^ #BogusC! !

!MDTestCase methodsFor: 'constructing' stamp: 'avi 11/29/2004 12:49'!
methodSnapshot
	^MDElementDefinition forElement: (MDMethodElement 
										className: self defaultClassName
										selector: self defaultSelector)! !

MDTestCase subclass: #MDFakedTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

MDFakedTestCase subclass: #MDTestWorkingCopy
	instanceVariableNames: 'wc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDTestWorkingCopy methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 14:55'!
assertNoConflictIncluding: anElementVersion
	wc includeVersion: anElementVersion onConflict: [:a :b | self assert: false. ^self]! !

!MDTestWorkingCopy methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 14:15'!
testLoadOldVersion
	| version newVersion |
	version _ self methodVersion.
	version snapshot properties source: self defaultSource.
	newVersion _ self updateVersion: version property: #source put: self changedSource.
	wc loadVersion: newVersion.
	self assert: (self methodProperty: #source) = self changedSource.
	wc loadVersion: version.
	self assert: (self methodProperty: #source) = self defaultSource.
! !

!MDTestWorkingCopy methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 14:58'!
testResolveConflict
	| version newVersion newVersion2 mergedVersion |
	version _ self methodVersion.
	version snapshot properties source: self defaultSource.
	newVersion _ self updateVersion: version property: #source put: self changedSource.
	newVersion2 _ self updateVersion: version property: #source put: self changedSource2.
	wc loadVersion: newVersion.
	wc includeVersion: newVersion2 onConflict: [:a :b | b snapshot].
	self assert: (self methodProperty: #source) = self changedSource2.
	mergedVersion _ wc versionForElement: version element.
	self assert: (mergedVersion snapshot = newVersion2 snapshot).
	self assert: (mergedVersion supercedes: newVersion).
	self assert: (mergedVersion supercedes: newVersion2).! !

!MDTestWorkingCopy methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 13:19'!
testLoad
	| version |
	version _ self methodVersion.
	version snapshot properties source: self defaultSource.
	wc loadVersion: version.
	self assert: (self methodProperty: #source) = self defaultSource! !

!MDTestWorkingCopy methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 12:52'!
setUp
	super setUp.
	wc _ MDWorkingCopy forImageProxy: proxy.! !

!MDTestWorkingCopy methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 14:55'!
assertConflictIncluding: anElementVersion
	wc includeVersion: anElementVersion onConflict: [:a :b | ^ self].
	self assert: false! !

!MDTestWorkingCopy methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 14:57'!
testIncludeConflictingVersion
	| version newVersion newVersion2 |
	version _ self methodVersion.
	version snapshot properties source: self defaultSource.
	newVersion _ self updateVersion: version property: #source put: self changedSource.
	newVersion2 _ self updateVersion: version property: #source put: self changedSource2.
	wc loadVersion: newVersion.
	self assertConflictIncluding: newVersion2! !

!MDTestWorkingCopy methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 14:29'!
testIncludeNewVersion
	| version newVersion |
	version _ self methodVersion.
	version snapshot properties source: self defaultSource.
	wc loadVersion: version.
	newVersion _ self updateVersion: version property: #source put: self changedSource.
	self assertNoConflictIncluding: newVersion.
	self assert: (self methodProperty: #source) = self changedSource! !

!MDTestWorkingCopy methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 14:34'!
testModifyAndIncludeConflictingVersion
	| version newVersion |
	version _ self methodVersion.
	version snapshot properties source: self defaultSource.
	wc loadVersion: version.
	newVersion _ self updateVersion: version property: #source put: self changedSource.
	self methodProperty: #source put: self changedSource, '""'.
	self assertConflictIncluding: newVersion! !

!MDTestWorkingCopy methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 13:43'!
testLoadModifyAndSave
	| version newVersion |
	version _ self methodVersion.
	version snapshot properties source: self defaultSource.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version.
	self methodProperty: #source put: self changedSource.
	newVersion _ wc versionForElement: version element.
	self deny: newVersion == version.
	self assert: (newVersion supercedes: version).! !

!MDTestWorkingCopy methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 13:40'!
testLoadAndSave
	| version |
	version _ self methodVersion.
	version snapshot properties source: self defaultSource.
	wc loadVersion: version.
	self assert: (wc versionForElement: version element) == version! !

!MDTestWorkingCopy methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 14:29'!
testIncludeOldVersion
	| version newVersion |
	version _ self methodVersion.
	version snapshot properties source: self defaultSource.
	newVersion _ self updateVersion: version property: #source put: self changedSource.
	wc loadVersion: newVersion.
	self assert: (self methodProperty: #source) = self changedSource.
	self assertNoConflictIncluding: version.
	self assert: (self methodProperty: #source) = self changedSource.
! !

!MDFakedTestCase methodsFor: 'configuration' stamp: 'avi 11/29/2004 12:52'!
methodProperty: aSymbol inClass: aString atSelector: aSelector 
	| element |
	element := MDMethodElement className: aString selector: aSelector.
	^ (proxy at: element) at: aSymbol ifAbsent: [nil]! !

!MDFakedTestCase methodsFor: 'configuration' stamp: 'avi 11/29/2004 12:52'!
proxyClass
	^ MDFakeImageProxy! !

!MDFakedTestCase methodsFor: 'configuration' stamp: 'avi 11/29/2004 12:52'!
methodProperty: aSymbol inClass: aString atSelector: aSelector put: aValue 
	| element |
	element := MDMethodElement className: aString selector: aSelector.
	(proxy at: element) at: aSymbol put: aValue! !

Object subclass: #MDElementVersion
	instanceVariableNames: 'snapshot info ancestry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:54'!
fullAncestry
	^ ancestry copyWith: info! !

!MDElementVersion methodsFor: 'comparing' stamp: 'avi 11/29/2004 13:54'!
supercedes: anElementVersion
	^ self ancestry includes: anElementVersion info! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:54'!
info
	^ info! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:17'!
snapshot
	^ snapshot! !

!MDElementVersion class methodsFor: 'instance creation' stamp: 'avi 11/29/2004 12:56'!
snapshot: anElementSnapshot
	^ self snapshot: anElementSnapshot ancestry: Set new! !

!MDElementVersion methodsFor: 'initialize-release' stamp: 'avi 11/29/2004 12:31'!
initializeWithSnapshot: elementSnapshot ancestry: aCollection
	snapshot _ elementSnapshot.
	ancestry _ aCollection.
	info _ MDElementVersionInfo forSnapshot: snapshot! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:39'!
element
	^ snapshot element! !

!MDElementVersion class methodsFor: 'instance creation' stamp: 'avi 11/29/2004 12:31'!
snapshot: anElementSnapshot ancestry: aSet
	^ self basicNew initializeWithSnapshot: anElementSnapshot ancestry: aSet! !

!MDElementVersion methodsFor: 'accessing' stamp: 'avi 11/29/2004 13:53'!
ancestry
	^ ancestry! !

Object subclass: #MDImageElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDImageElement methodsFor: 'image proxy' stamp: 'avi 11/29/2004 13:27'!
is: propDict upToDateFor: anImageProxy
	self subclassResponsibility! !

!MDImageElement methodsFor: 'image proxy' stamp: 'avi 11/28/2004 16:08'!
load: propDict into: anImageProxy
	self subclassResponsibility! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
= other
	self subclassResponsibility ! !

!MDImageElement methodsFor: 'comparing' stamp: 'avi 11/28/2004 16:02'!
hash
	self subclassResponsibility ! !

MDImageElement subclass: #MDMethodElement
	instanceVariableNames: 'className selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDMethodElement methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 13:01'!
update: propDict from: anImageProxy
	anImageProxy update: propDict forMethodElement: self! !

!MDMethodElement methodsFor: 'initialize-release' stamp: 'avi 11/28/2004 16:02'!
initializeWithClassName: aString selector: aSymbol
	className _ aString.
	selector _ aSymbol! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
selector
	^ selector! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 11/28/2004 15:23'!
hash
	^ (className, '|', selector) hash! !

!MDMethodElement methodsFor: 'comparing' stamp: 'cwp 11/28/2004 15:21'!
= other
	^ self class = other class 
		and: [className = other className] 
		and: [self selector = other selector]! !

!MDMethodElement methodsFor: 'image proxy' stamp: 'avi 11/29/2004 13:28'!
is: propDict upToDateFor: anImageProxy
	^ anImageProxy is: propDict upToDateForMethodElement: self! !

!MDMethodElement methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:26'!
className
	^ className! !

!MDMethodElement methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:59'!
load: propDict into: anImageProxy
	anImageProxy load: propDict forMethodElement: self! !

!MDMethodElement class methodsFor: 'as yet unclassified' stamp: 'avi 11/28/2004 16:02'!
className: aString selector: aSymbol
	^ self basicNew initializeWithClassName: aString selector: aSymbol! !

!MDImageElement methodsFor: 'image proxy' stamp: 'avi 11/28/2004 16:08'!
update: propDict from: anImageProxy
	self subclassResponsibility! !

Object subclass: #MDImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

MDImageProxy subclass: #MDFakeImageProxy
	instanceVariableNames: 'dict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Tests'!

!MDFakeImageProxy methodsFor: 'public' stamp: 'avi 11/29/2004 13:30'!
load: propDict forMethodElement: aMethodElement
	self at: aMethodElement put: propDict copy! !

!MDFakeImageProxy methodsFor: 'initialize-release' stamp: 'avi 11/28/2004 16:23'!
initialize
	dict _ Dictionary new! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 15:25'!
at: anElement put: aPropertyDictionary
	dict at: anElement put: aPropertyDictionary! !

!MDFakeImageProxy methodsFor: 'public' stamp: 'cwp 11/28/2004 15:34'!
update: propDict forMethodElement: aMethodElement
	(self at: aMethodElement)
		keysAndValuesDo: [:prop :value | propDict at: prop put: value]! !

!MDFakeImageProxy methodsFor: 'public' stamp: 'avi 11/29/2004 13:29'!
is: propDict upToDateForMethodElement: aMethodElement
	^ propDict = (self at: aMethodElement)! !

!MDFakeImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 15:35'!
at: anElement
	^ dict at: anElement ifAbsentPut: [Dictionary new]! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/29/2004 13:26'!
isUpToDate: anElementSnapshot
	^ anElementSnapshot isUpToDateFor: self! !

MDImageProxy subclass: #MDSqueakImageProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDSqueakImageProxy methodsFor: 'public' stamp: 'cwp 11/29/2004 01:10'!
load: properties forMethodElement: aMethodElement 
	| class |
	class := self classNamed: aMethodElement className.
	class
		compile: properties source
		classified: properties category
		withStamp: (self stampFromProperties: properties)
		notifying: nil
		logSource: true! !

!MDSqueakImageProxy methodsFor: 'private' stamp: 'cwp 11/29/2004 01:43'!
putAuthorInto: properties forMethod: aMethodElement 
	| cm |
	cm := self compiledMethodForElement: aMethodElement.
	properties author: (cm timeStamp copyUpTo: $ )! !

!MDSqueakImageProxy methodsFor: 'private' stamp: 'cwp 11/29/2004 01:40'!
compiledMethodForElement: aMethodElement 
	^(self classNamed: aMethodElement className) 
		compiledMethodAt: aMethodElement selector! !

!MDSqueakImageProxy methodsFor: 'public' stamp: 'cwp 11/29/2004 01:19'!
update: properties forMethodElement: aMethodElement 
	self putSourceInto: properties forMethod: aMethodElement.
	self putTimeStampInto: properties forMethod: aMethodElement.
	self putAuthorInto: properties forMethod: aMethodElement.! !

!MDSqueakImageProxy methodsFor: 'private' stamp: 'cwp 11/29/2004 01:42'!
putTimeStampInto: properties forMethod: aMethodElement 
	| cm |
	cm := self compiledMethodForElement: aMethodElement.
	properties timeStamp: (TimeStamp fromMethodTimeStamp: cm timeStamp)! !

!MDSqueakImageProxy methodsFor: 'private' stamp: 'cwp 11/28/2004 23:48'!
classNamed: name 
	^ Smalltalk at: name asSymbol! !

!MDSqueakImageProxy methodsFor: 'private' stamp: 'cwp 11/29/2004 01:06'!
stampFromProperties: properties
	^ String streamContents: 
		[:stream |
		stream nextPutAll: properties author.
		stream nextPut: $ .
		properties timeStamp asDate printOn: stream format: #(2 1 3 $/ 1 1).
		stream nextPut: $ .
		properties timeStamp asTime print24: true showSeconds: false on: stream]
		! !

!MDSqueakImageProxy methodsFor: 'private' stamp: 'cwp 11/29/2004 01:21'!
putSourceInto: properties forMethod: aMethodElement 
	properties source: ((self classNamed: aMethodElement className) 
						sourceCodeAt: (aMethodElement selector)).! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/28/2004 16:07'!
loadSnapshot: aSnapshot
	aSnapshot loadInto: self! !

!MDImageProxy methodsFor: 'public' stamp: 'avi 11/28/2004 16:06'!
updateSnapshot: aSnapshot
	aSnapshot updateFrom: self! !

Object subclass: #MDElementDefinition
	instanceVariableNames: 'element properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDElementDefinition methodsFor: 'copying' stamp: 'avi 11/29/2004 14:16'!
copy
	| new |
	new _ self species forElement: element.
	properties keysAndValuesDo:
		[:k :v|
		new properties at: k put: v].
	^ new! !

!MDElementDefinition methodsFor: 'accessing' stamp: 'avi 11/28/2004 16:06'!
properties
	^ properties! !

!MDElementDefinition methodsFor: 'accessing' stamp: 'cwp 11/28/2004 12:56'!
element
	^ element! !

!MDElementDefinition methodsFor: 'initialize-release' stamp: 'cwp 11/29/2004 00:50'!
initializeWithElement: anElement
	element _ anElement.
	properties _ MDPropertyDictionary new! !

!MDElementDefinition class methodsFor: 'instance creation' stamp: 'cwp 11/28/2004 12:52'!
forElement: anElement
	^ self basicNew initializeWithElement: anElement! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'avi 11/29/2004 13:27'!
isUpToDateFor: anImageProxy
	^ element is: properties upToDateFor: anImageProxy! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:55'!
updateFrom: anImageProxy
	element update: properties from: anImageProxy! !

!MDElementDefinition methodsFor: 'image proxy' stamp: 'cwp 11/28/2004 12:54'!
loadInto: anImageProxy
	element load: properties into: anImageProxy! !

Object subclass: #MDWorkingCopy
	instanceVariableNames: 'proxy versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDWorkingCopy methodsFor: 'private' stamp: 'avi 11/29/2004 13:53'!
newVersionForElement: anImageElement
	| oldVersion newSnapshot |
	oldVersion _ versions at: anImageElement.
	newSnapshot _ oldVersion snapshot copy.
	proxy updateSnapshot: newSnapshot.
	^ MDElementVersion
		snapshot: newSnapshot
		ancestry: oldVersion fullAncestry! !

!MDWorkingCopy methodsFor: 'private' stamp: 'avi 11/29/2004 15:01'!
resolveConflictBetween: oldVersion and: newVersion using: aBlock
	| mergedSnapshot mergedVersion |
	mergedSnapshot _ aBlock value: oldVersion value: newVersion.
	mergedVersion _ MDElementVersion
						snapshot: mergedSnapshot
						ancestry: (oldVersion fullAncestry, newVersion fullAncestry).
	self loadVersion: mergedVersion! !

!MDWorkingCopy methodsFor: 'initialize-release' stamp: 'avi 11/29/2004 13:40'!
initializeWithImageProxy: anImageProxy
	proxy _ anImageProxy.
	versions _ Dictionary new! !

!MDWorkingCopy methodsFor: 'load and save' stamp: 'avi 11/29/2004 13:41'!
loadVersion: anElementVersion
	versions at: anElementVersion element put: anElementVersion.
	proxy loadSnapshot: anElementVersion snapshot! !

!MDWorkingCopy class methodsFor: 'as yet unclassified' stamp: 'avi 11/29/2004 12:56'!
forImageProxy: anImageProxy
	^ self basicNew initializeWithImageProxy: anImageProxy! !

!MDWorkingCopy methodsFor: 'load and save' stamp: 'avi 11/29/2004 15:01'!
includeVersion: anElementVersion onConflict: twoArgBlock
	| currentVersion |
	currentVersion _ self versionForElement: anElementVersion element.
	(anElementVersion supercedes: currentVersion)
		ifTrue: [self loadVersion: anElementVersion. ^ true].
	(currentVersion supercedes: anElementVersion)
		ifTrue: [^ false].
	self resolveConflictBetween: currentVersion and: anElementVersion using: twoArgBlock.
	^ true! !

!MDWorkingCopy methodsFor: 'load and save' stamp: 'avi 11/29/2004 13:55'!
versionForElement: anImageElement
	| old |
	old _ versions at: anImageElement.
	^ (proxy isUpToDate: old snapshot)
		ifTrue: [old]
		ifFalse: [self newVersionForElement: anImageElement]! !

Object subclass: #MDElementVersionInfo
	instanceVariableNames: 'timeStamp hash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Versions'!

!MDElementVersionInfo class methodsFor: 'instance creation' stamp: 'avi 11/29/2004 12:32'!
forSnapshot: anElementSnapshot
	^ self basicNew initializeFromSnapshot: anElementSnapshot! !

!MDElementVersionInfo methodsFor: 'accessing' stamp: 'avi 11/29/2004 12:34'!
timeStamp
	^ timeStamp! !

!MDElementVersionInfo methodsFor: 'initialize-release' stamp: 'avi 11/29/2004 13:56'!
initializeFromSnapshot: anElementSnapshot
	timeStamp _ TimeStamp current.
	hash _ timeStamp hash.
	anElementSnapshot properties do:
		[:ea |
		hash _ hash bitXor: ea hash].
	! !

!MDElementVersionInfo methodsFor: 'accessing' stamp: 'avi 11/29/2004 12:34'!
hash
	^ hash! !

!MDElementVersionInfo methodsFor: 'comparing' stamp: 'avi 11/29/2004 12:35'!
= other
	^ other species = self species
		and: [other timeStamp = self timeStamp]
		and: [other hash = self hash]! !

Dictionary subclass: #MDPropertyDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Monticello2-Elements'!

!MDPropertyDictionary methodsFor: 'as yet unclassified' stamp: 'cwp 11/29/2004 00:49'!
doesNotUnderstand: aMessage
	aMessage selector isUnary ifTrue: [^ self at: aMessage selector ifAbsent: [nil]].
	(aMessage selector isKeyword
		and: [aMessage arguments size = 1])
			ifTrue: [^ self
						at: aMessage selector allButLast asSymbol
						put: aMessage arguments first].
	super doesNotUnderstand: aMessage.! !
